/****************************************************************************
 *
 * Engine Include File
 *
 ***************************************************************************/

/****************************************************************************
 *
 * State defines
 *
 ***************************************************************************/

#define  MODE0    0							/* point plot */
#define  MODE1    1							/* line plot */
#define  MODE2    2							/* load memory */
#define  MODE3    3							/* plot character */
#define  MODE4    4							/* filled area */
#define  MODE5    5							/* user mode 1 */
#define  MODE6    6							/* user mode 2 */
#define  MODE7    7							/* user mode 3 */

#ifdef   LEVEL1
#define  MODE8	   8							/* arc mode */
#define  MODE9	   9 							/* circle mode */
#define  MODE10	10						   /* ellipse mode */
#define  MODE11   11						   /* rectangle mode */
#define  MODE12   12						   /* char slot mode */
#define  MODE13   13                   /* rounded arc mode */
#define  MODE14   14                   /* external mode */
#endif

#define  LDC      20                   /* load coordinate */
#define  SSF      21                   /* ssf */
#define  EXT      22                   /* external data */
#define  LDA      23                   /* load memory address */
#define  LDE      24                   /* load echo */
#define  FGCOLOR  25                   /* foreground color */
#define  BGCOLOR  26                   /* background color */
#define  PAINT    27                   /* paint */

#ifdef   LEVEL1
#define  ESCI	   28                   /* escape i */
#define  FGPAL	   29                   /* foreground palette slot */
#define  BGPAL	   30                   /* background palette slot */
#define  SETPAL	31                   /* set palette entry */
#define  ESCQ	   32                   /* escape q */
#define  ESCV	   33                   /* escape v */
#define  ESCX	   34                   /* escape x */
#define  CENTX	   35                   /* load x offset */
#define  CENTY    36                   /* load y offset */
#define  DELAY	   37                   /* delay */
#define  CLIP	   38                   /* set clipping rectangle */
#endif

/****************************************************************************
 *
 * State Definitions
 *
 ***************************************************************************/

#define  LDBYTE   0                    /* load byte */
#define  LDWORD   1                    /* load word */
#define  LDCOORD  2                    /* load coordinate */
#define  LDCOLOR  3                    /* load color */
#define  LDSLOT	4                    /* load slot */

/****************************************************************************
 *
 * PLATO Virtual Terminal Definitions
 *
 ***************************************************************************/

#define  SCWRITE     0                 /* screen write mode */
#define  SCERASE     1                 /* screen erase mode */
#define  SCREWRITE   2                 /* screen rewrite mode */
#define  SCINVERSE   3                 /* screen inverse mode */

#define  HORIZONTAL  0                 /* horizontal plotting */
#define  VERTICAL    1                 /* vertical plotting */
#define  FORWARD     0                 /* forward plotting */
#define  REVERSE     1                 /* reverse plotting */

#define  PLOT        ((textAxis*2)+textDir)

/*  0 = HORIZONTAL FORWARD
 *  1 = HORIZONTAL REVERSE
 *  2 = VERTICAL   FORWARD
 *  3 = VERTICAL   REVERSE
 */

#define  CHARWIDTH   8                 /* character width on plato */
#define  CHARHEIGHT  16                /* character height on plato */






