/****************************************************************************
 *
 * Engine Variables
 *
 ***************************************************************************/

/* Virtual Terminal Variables */

WORD  platoXMax;                       /* width of virtual screen */
WORD  platoYMax;                       /* height of virtual screen ( 512 ) */

BYTE  ttyMode;                         /* in ttymode if True */
WORD  screenMode;                      /* current screen mode of terminal */

WORD  currentX;                        /* current x location */
WORD  currentY;                        /* current y location */

WORD  intMask;				/* interrupt mask */
WORD  screenTouch;			/* true if screen touch enabled */

WORD  textCharset;                     /* current charset working in */
BYTE  textDir;                         /* text plotting direction */
BYTE  textAxis;                        /* text plotting axis */
BYTE  textSize;                        /* text size */
WORD  textMargin;                      /* text margin */
DOUBLE   memAddr;                      /* memory address */
WORD  subType;                         /* terminal subtype */
WORD	centerX, centerY;						/* centering stuff */

COLOR	fgColor, bgColor;				/* colors */

WORD	buildChar [ 8 ];				/* for putting together charsets */
BYTE	charBitMap [ 16 ];				/* converted bitmap */
WORD	buildCount;						/* counter of words received */

#ifdef   LEVEL1      
BYTE  upEnhance;                       /* upline enhancements */
BYTE  wordCoord;                       /* true if in word coordinate mode */
WORD  palHold;						   /* palette hold flag */
#endif

/* Engine Support Variables */

BYTE  escPending;                      /* escape pending flag */
BYTE  flowActive;                      /* True if flow control on */
BYTE  flowAvail;                       /* True if flow control available */
WORD  comState;                        /* command state of pad */
WORD  curState;                        /* current state of pad */
WORD  comMode;                         /* command mode in pad */
WORD  curMode;                         /* current mode in pad */
BYTE  memConv;                         /* char conversions for ldm */

/* Data Constuction Support variables */

BYTE  ldByte;                          /* load byte */
DOUBLE  ldWord;                        /* load word */
WORD  seqWord;                         /* word sequence */
WORD  ldX, ldY;                        /* load coordinates */
WORD  seqCoord;                        /* coordinate sequence */
WORD  ldSlot;                          /* load slot */
WORD  seqSlot;                         /* slot sequence */
COLOR ldColor;                         /* load color */
WORD  seqColor;                        /* color sequence */

#ifdef   LEVEL1
WORD  seqWCoord;                       /* word coordinate sequence */
WORD	seqI;										/* escape I sequence */
WORD  seqQ;										/* escape Q sequence */
WORD	seqV;										/* escape V sequence */
#endif

/* Mode Support variables */

WORD  seqMode1;                        /* mode 1 sequence */
WORD  seqMode4;                        /* mode 4 sequence */

#ifdef	LEVEL1
WORD	seqClip;									/* clipping sequence */
WORD	seqPal;									/* setting palette entries */
WORD	seqMode;									/* mode sequencing */
#endif
