/****************************************************************************
 *
 * 	Event Processing Routines
 *
 ***************************************************************************/

#include 	<stdio.h>
#include	<sys/file.h>
#include	<suntool/sunview.h>
#include	<suntool/canvas.h>
 
#include 	"machdef.h"
#include 	"types.h"
#include 	"engine.h"
#include	"pkeyboard.h"

/****************************************************************************
 *
 * 	Externals
 *
 ***************************************************************************/

extern Frame	frame;
extern Pixwin	*pw;
extern WORD	screenTouch;
extern BYTE	ttyMode;

/***************************************************************************
 *
 *	Globals
 *
 **************************************************************************/

int	unshiftFunc [] = { COPY, ANS, SQUARE, MICRO, EDIT, HELP, LAB, BACK, DATA, 0 };
int	shiftFunc [] = { COPY1, TERM, ACCESS, FONT, EDIT1, HELP1, LAB1, BACK1, DATA1, 0 };

/**************************************************************************
 *
 *	EventProcess ( canvas, event, data )
 *
 *	Process events from our little window
 *
 *************************************************************************/

int	EventProcess ( canvas, event, data )

Canvas	canvas;
Event	*event;

{
	int	eventID = event->ie_code;
	int	temp;
	int	tempX, tempY;

	/* control-k keyboard toggle was removed */

	if ( eventID <= ASCII_LAST ) { 		/* normal keyboard character */	
		SendAscii ( eventID , GetStatus ( event ), ttyMode );
	}

	else if ( event_is_up ( event ) ) {
	}

	else if ( event_is_key_top ( event ) ) {	/* must be in the top row */
		temp = eventID - KEY_TOP ( 1 );
		if ( event_shift_is_down ( event ) ) SendFunc ( shiftFunc[temp] );
		else SendFunc ( unshiftFunc[temp] );
	}

	else if ( eventID == KEY_RIGHT ( 1 ) ) {
		if ( event_shift_is_down ( event ) ) SendFunc ( STOP1 );
		else SendFunc ( STOP );
	}

	else if ( eventID == KEY_RIGHT ( 11 ) ) 
		TextKey ();

#ifdef	UNDEF
	
	else if ( eventID == BUT ( 1 ) ) {		/* rodent got stomped on */
		if ( screenTouch ) {
			tempX = (event_x ( event ) >> 5) & 0x0f;
			tempY = (event_y ( event ) >> 5) & 0x0f;
			SendTouch ( tempX, tempY );
		}
	}
#endif

}

/**************************************************************************
 *
 *	InterposerProcess ( frame, event, arg, type )
 *
 *	Process events from our little window (this interposes)
 *
 *************************************************************************/

Notify_value	InterposerProcess ( frame, event, arg, type )

Frame	frame;
Event	*event;
Notify_arg	arg;
Notify_event_type	type;

{
	int	eventID = event->ie_code;
	int	tempX, tempY;
	Notify_value	value = NOTIFY_DONE;
	if ( eventID == 0x3f )
		SendAscii ( eventID, GetStatus ( event ), ttyMode );
	else
		value = notify_next_event_func ( frame, event, arg, type );
	return value;
}

/**************************************************************************
 *
 *	GetStatus ()
 *
 *	Build a keyboard status word
 *
 *************************************************************************/

int	GetStatus ( event )

Event	*event;

{
	int	temp = 0;

	if ( event_shift_is_down (event ) ) temp = SHIFTED;

	if ( event_ctrl_is_down (event) ) temp += ALTED;
	return temp;
}
